---- Supports interface
-- @author Oskar Eisemuth
-- @copyright 2020
-- @module commonapi.supports
local supports = {
}

local supportHelpers = {
	LINE_DESTINATION = function()
		if (commonapi._native ~= nil)  then
			if (commonapi._native.LabelSystem ~= nil) then
				return commonapi._native.LabelSystem.isEnabled()
			end
		end
		return false;
	end,
	TEST_FALSE = function()
		return false;
	end
}

local supports_metatable = {
	__newindex = function(self, key, value)
		print(debug.traceback("commonapi.supports trying to set key "..key.." not allowed", 2))
	end,
	__index = function(t, key)
		if (supportHelpers[key] ~= nil) then
			return supportHelpers[key]()
		end
		return nil
	end,
	__call = function(t, key)
		if (supportHelpers[key] ~= nil) then
			return supportHelpers[key]()
		end
		return false
	end,
	__pairs = function(t)
		local function stateless_iter(t, k)
			local v
			k, v = next(supportHelpers, k)
			if nil ~= v then return k, v() end
		end
		return stateless_iter, t, nil
	end,
	__metatable = false
}

setmetatable(supports, supports_metatable)
return supports