local test = {} 

if (commonapi.ui == nil) then
	test.run = function()
		print("commonapi.ui not available")
	end
	return test
end

local nativeui = commonapi.ui

local samplewindow = nativeui.Window:new()
samplewindow.id =  "nativeui_testwindow1"
samplewindow.uilist = {
	{
		typ = "Label", 
		id = "numTerminalsIndex_label",
		caption = _("Number of terminals"),
	},
	{
		typ = "Buttons", 
		id = "numTerminalsIndex",
		values = { _("1"), _("2"), _("3") },
		defaultIndex = 2
	},

	{
		typ = "Label", 
		id = "Label",
		caption = _("Test"),
	},
	{
		typ = "TextInput",
		id = "Input",
		default = "defaultText",
	},

	{
		typ = "Label", 
		id = "Label2",
		caption = _("Float:"),
	},
	{
		typ = "FloatValue",
		id = "Float",
		default = 0.1,
		step = 0.001,
		decimalPlaces = 3,
		minValue = -10,
		maxValue = 10,
	},
	{
		typ = "Label", 
		id = "Label3",
		caption = _("Int:"),
	},
	{
		typ = "IntValue",
		id = "Int",
		default = 0,
		step = 2,
		minValue = -10,
		maxValue = 10,
	},
	{
		typ = "Label", 
		id = "LabelComboBox",
		caption = _("ComboBox:"),
	},
	{
		typ = "ComboBox",
		id = "ComboBox",
		values = { _("1"), _("2"), _("3") },
		defaultIndex = -1
	}
}

function samplewindow:onchange()
	commonapi.dmp(self.params);
end


local samplewindow2 = nativeui.Window:new()
samplewindow2.id =  "nativeui_testwindow2"
samplewindow2.caption = "Sample Window Two"
samplewindow2.width = 200
samplewindow2.uilist = {
	{
		typ = "Label", 
		id = "terminals_label",
		caption = _("Number of terminals"),
	},
	{
		typ = "Buttons", 
		id = "terminals",
		values = { _("1"), _("2"), _("3") },
		defaultIndex = 1
	}
}
function samplewindow2:onchange()
	commonapi.dmp(self.params);
end

local function menucallback()
	samplewindow:open()
	samplewindow2:open()
end

local function reloadcallback()
	package.loaded["commonapi.tests.ui"] = nil
	print("Reload callback called")
	local uitest = require "commonapi.tests.ui"
	uitest.run()
end


function test.run()
	nativeui.createModMenuEntry('test_nativeui', "Test Native UI (Open)", menucallback)
	nativeui.createModMenuEntry('test_nativeui_reload', "Test Native UI (Reload)", reloadcallback)
end

return test